--  ##################################
--  ####  Gcrew's Defense Patrol  ####
--  ##################################
--  ####  By: DeViaNTe @ GCREW    ####
--  #### (c) 2011 - www.gcrew.es  ####
--  ##################################

-- @tester
os.cpu(333);

do
 local a = image.load("img/genesis.png");
 for i=1,255,10 do a:blend(0,0,i); screen.flip(); end
 os.sleep(3.5);
 for i=255,0,-10 do a:blend(0,0,i); screen.flip(); end
 a:free(); a = nil; collectgarbage("collect");
end
os.luasplash();
os.luadevsplash();

-- @import things...
dofile("lighting.lua");
dofile("muplayer.lua");
dofile("language.lua");
dofile("modeling.lue");

--@mainconfig
loadconfig();

controlswrapped = controls.read;
function fuckcontrols() controls.read = function() end; end
function restorecontrols() controls.read = controlswrapped; end
cdown = controls.down;
cup = controls.up;

function unflipcontrols() controls.up = cup; controls.down = cdown; end
function flipcontrols() if pla.invertaxis then controls.up = cdown; controls.down = cup; else unflipcontrols(); end end

-- @first splash
--os.luadevsplash();
--os.luasplash();

-- @game splash + loadinga
do
	-- @logo image
	im.load("upgrade","res/midwin.png",false);		im.setalpha("upgrade",0);
	im.load("complete","res/miscomp.png",true);		im.setalpha("complete",0);
	im.load("logo","img/logo.png",true);			im.setpos("logo",240,136);	im.setalpha("logo",0);
	im.load("load","img/loader.png",true); 			im.setpos("load",20,262);	im.setalpha("load",0);	im.makerot("load");
	im.text("pstart",240,195,text.pstart,255,255,255,0,true,"blinking");
	im.text("tuto",240,10,"TUTORIAL",255,255,255,0,true,"blinking"); im.setalpha("tuto",0);
	im.text("xtocont",430,260,text.xtocont,255,255,255,0,true,"blinking"); im.setalpha("xtocont",255);
	
	__loading_text = "";
	loadcallback = function()
		im.fadeto("logo",255);
		im.fadeto("load",255);
		im.blit("logo");
		im.blit("load");
		local t = im.getalpha("load");
		screen.print(40,259,text.cargando,color.new(255,255,255,t));
		screen.print(40+screen.textwidth(text.cargando.." "),259,__loading_text,color.new(200,200,255,t));
		screen.flip();
	end;
	
	-- @load resources
	__loading_text = text.cargandomusica; 		music.loadall(); music.switch(4);
	__loading_text = text.cargandoarwing; 		models.arwingload();
	__loading_text = text.cargandomenuprin;		stages.init();
	__loading_text = text.cargandomusica; 		en.loadall(); wp.loadall(); stages.preload(1);
	
	-- @disappear on finished
	im.speed("load",5); im.fadeto("load",0);
	while im.getalpha("load") > 0 do
		im.blit("logo"); im.blit("load");
		screen.print(40,259,text.cargado,color.new(255,255,255,im.getalpha("load")));
		screen.print(40+screen.textwidth(text.cargado.." "),259,text.cargandofin,color.new(200,255,200,im.getalpha("load")));
		screen.flip();
	end
	collectgarbage("collect");
end

models.fog.acolor2 = color.new(0,0,0); 
models.fog.color2 = color.new(0,0,0); 
models.fog.rp1 = 0; 
models.fog.p1 = 0; 
models.fog.update(10,15);

-- @main menu
function mainmenu()
	-- @first impressions...
	stages.cs = 1; stages.cp = 1; stages.csp = 1;
	world.lights(1);		world.update();
	models.fog.set(0,1);	models.fog.update(500,1000);
	im.fadeto("pstart",255);
	im.speed("logo",2); im.moveto("logo",240,90); im.fadeto("logo",255);
	menushown = false;
	music.switch(1);
	pla.overridecontrols = true;	pla.oz = 200;
	local quitin = false;
	local newgamein = false;
	local contgamein = false;
	local updategamein = false;
	restorecontrols();
	models.fog.acolor1 = color.new(100,100,160); 
	models.fog.color1 = color.new(255,255,255); 
	models.fog.rp1 = 100; 

	while true do		
		if quitin and os.clock() > quitin then os.exit(); end
		if newgamein and os.clock() > newgamein then return 1; end
		if contgamein and os.clock() > contgamein then return 2; end
		if updategamein and os.clock() > updategamein then return 3; end
		
		stages.blit();
		pla.fly();
		pla.blit();
		im.blit("logo");		
		draw.fillrect(0,189,480,20,color.new(0,0,0,math.min(im.getalpha("pstart"),60)));
		im.blit("pstart");
		screen.print(240,260,"(c) 2011 - DeViaNTe @ Gcrew - www.gcrew.es",0.7,models.fog.fcolor,0x0,"center",480);
		if menushown then
			stages.rrz = (math.pi / 32) * menu.opc;
			local sel = menu.exec();
			if ( sel ) then
				models.fog.acolor2 = color.new(0,0,0); 
				models.fog.color2 = color.new(0,0,0); 
				models.fog.rp1 = 0; 
				models.fog.update(10,15);				
				menushown = false;
				im.speed("logo",10); im.fadeto("logo",0);
				fuckcontrols();
				if (sel == 0 ) then newgamein = os.clock() + 2.2; end
				if (sel == 1 ) then contgamein = os.clock() + 2.2; end
				if (sel == 2 ) then updategamein = os.clock() + 2.2; end
				if (sel == 3 ) then quitin = os.clock() + 2.2; end
			end
		end
		screen.flip();
		
		--if controls.press("triangle") then lightstation(blitter); end
		
		if menushown == false then
			-- @Controls not menu
			if controls.press("start") then
				menushown = true;
				menu.sxoffset = 0;
				menu.rxoffset = 600;
				menu.malpha = 0;
				menu.malphad = 10;
				menu.opc = 0;
				im.speed("pstart",10); im.fadeto("pstart",0);
			end
		else
			-- @controls on menu
			if controls.press("circle") then
				menushown = false;
				stages.rrz = math.pi / 16;
				im.speed("pstart",10); im.fadeto("pstart",255);
			end
		end
	end
end

--@options menu
function options()
	local curcallback = loadcallback;
	unflipcontrols();
	loadcallback = nil;
	music.switch(2);
	local option = 0;
	local bg = image.load("img/opt.png");
	local w = color.new(255,255,255);
	local r = color.new(0,128,200);
	local b = color.new(0,0,0);
	local ry = 0;
	local fs = 1;
	models.fog.set(1000,1010); models.fog.update();
	for i = 0, 255, 10 do
		ry = ry + 1; if ( ry > 360 ) then ry = ry - 360; end
		bg:blend(0,0,i);
		screen.print(240,30,text.actujuego,1,color.new(255,255,255,i),color.new(0,0,0,i),"center");
		models.arwing.model:rotation(math.rad(15),math.rad(ry),0);
		models.arwing.model:position(0,7,-80);
		models.arwing.model:blit();
		screen.flip();
	end
	restorecontrols();
	local oldmusicvol = music.maxvol;
	local oldinvert = pla.invertyaxis;
	local oldanalog = pla.useanalog;
	while true do
		controls.read();
		ry = ry + 1; if ( ry > 360 ) then ry = ry - 360; end
		bg:blit(0,0);
		screen.print(240,30,text.actujuego,1,w,b,"center");
		
		screen.print(240,160,text.optanalog.." "..iif(pla.useanalog,text.si,text.no),fs,iif(option==0,r,w),b,"center"); 
		screen.print(240,190,text.optinvert.." "..iif(pla.invertyaxis,text.si,text.no),fs,iif(option==1,r,w),b,"center"); 
		screen.print(240,220,text.optbgmvol.." "..music.maxvol.."%",fs,iif(option==2,r,w),b,"center");
		screen.print(240,250,text.optvolver,fs,iif(option==3,r,w),b,"center");
		models.arwing.model:rotation(math.rad(15),math.rad(ry),0);
		models.arwing.model:position(0,7,-80);
		models.arwing.model:blit();
		screen.flip();
		if controls.press("down") then option = math.min(option + 1,3); end
		if controls.press("up") then option = math.max(option - 1,0); end
		if (controls.press("left") or controls.press("right")) and option == 0 then pla.useanalog = not pla.useanalog; end
		if (controls.press("left") or controls.press("right")) and option == 1 then pla.invertyaxis = not pla.invertyaxis; end
		if (controls.left()) and option == 2 then music.maxvol = math.max(music.maxvol - 1,0) end
		if (controls.right()) and option == 2 then music.maxvol = math.min(music.maxvol + 1,99) end
		if controls.press("cross") and option == 3 then break; end
		if controls.press("circle") then music.maxvol = oldmusicvol; pla.invert = oldinvert; pla.useanalog = oldanalog; break; end
	end
		optionswindowry = ry;
	function bottomdialogcallback()
		optionswindowry = optionswindowry + 1; if ( optionswindowry > 360 ) then optionswindowry = optionswindowry - 360; end
		bg:blit(0,0);
		screen.print(240,30,text.actujuego,1,color.new(255,255,255),color.new(0,0,0),"center");
		models.arwing.model:rotation(math.rad(15),math.rad(optionswindowry),0);
		models.arwing.model:position(0,7,-80);
		models.arwing.model:blit();
	end
	saveconfig();
	bottomdialogcallback = nil;
	optionswindowry = nil;
	
	if pla.useanalog then controls.analogtodigital(40); else controls.analogtodigital(0); end
	
	for i = 0, 255, 10 do
		ry = ry + 1; if ( ry > 360 ) then ry = ry - 360; end
		bg:blit(0,0);
		screen.print(240,30,text.actujuego,1,color.new(255,255,255),color.new(0,0,0),"center");
		models.arwing.model:rotation(math.rad(15),math.rad(ry),0);
		models.arwing.model:position(0,7,-80);
		models.arwing.model:blit();
		draw.fillrect(0,0,480,272,color.new(0,0,0,i));
		screen.flip();
	end

	bg:free();
	loadcallback = curcallback;
	models.fog.set(10,15); models.fog.update();
	flipcontrols();
	return;
end

function starwarsparody()
	local cv = music.maxvol;
	for i=0,255,3 do screen.print(240,136,text.alongtime,1,color.new(0,math.floor(i/4),i,i),0x0,"center");  screen.flip(); end
	while music.maxvol > 0 do screen.print(240,136,text.alongtime,1,color.new(0,math.floor(255/4),255,255),0x0,"center"); music.maxvol = music.maxvol - 1; screen.flip(); end
	os.sleep(1); music.maxvol = cv; music.switch(3);
	for i=255,0,-1 do starfield.update(); draw.fillrect(0,0,480,272,color.new(0,0,0,i)); screen.print(240,136,text.alongtime,1,color.new(0,math.floor(i/4),i,i),0x0,"center");  screen.flip(); end
	for i=272,-232,-0.5 do starfield.update(); screen.print(120,i,text.introtext,0.66,color.new(255,255,0),0x0,"full",240); screen.flip(); end
	for i=272,-232,-0.5 do starfield.update(); screen.print(120,i,text.introtext2,0.66,color.new(255,255,0),0x0,"full",240); screen.flip(); end
	for i=272,-232,-0.5 do starfield.update(); screen.print(120,i,text.introtext3,0.66,color.new(255,255,0),0x0,"full",240); screen.flip(); end
	for i=0,255,10 do starfield.update(); draw.fillrect(0,0,480,272,color.new(0,0,0,i)); screen.flip(); end
end

while true do
	if pla.useanalog then controls.analogtodigital(40); else controls.analogtodigital(0); end
	local abc = mainmenu();
	draw.fillrect(0,0,480,272,color.new(0,0,0)); screen.flip();
	if abc == 1 then
		flipcontrols();
		-- @newgame
		--starwarsparody();
		-- @preload training zone, wait, no preload... just there!
		stages.cs = 1; stages.cp = 1; stages.csp = 1; world.lights(1);		world.update(); models.fog.set(0,1);	models.fog.update(500,1000); pla.overridecontrols = false;	pla.oz = 0; models.fog.acolor1 = color.new(100,100,160);  models.fog.color1 = color.new(255,255,255);  models.fog.rp1 = 100;  restorecontrols();
		music.switch(4);
		-- @tuto screen
		im.fadeto("tuto",255);
		local tutowhat;
		local spx = 1;
		local aciertos = 0;
		en.allow("tutor");
		enemycallback = function(a) aciertos = aciertos + 1; end
		while not tutoended do
			-- tuto data, meter en stage!
			world.lookat({0,0,0},{0,0,-1000},{math.clamp(math.sin(-pla.RZ*0.5),-0.5,0.5),math.clamp(math.cos(pla.RZ*0.5),-0.5,0.5),0});
			if not talk.showing then
				if spx == 12 then spx = spx + 1; tutostart = true; end
				if spx == 11 then if os.clock() > tutowhat then talk.mood = 2; talk.speech(1,text.tuto12); spx = spx + 1; end end
				if spx == 9 then if os.clock() > tutowhat then talk.mood = 1; talk.speech(1,text.tuto10..aciertos..iif(aciertos > 80,text.tuto11_1,iif(aciertos > 50,text.tuto11_2,iif(aciertos>30,text.tuto11_3,text.tuto11_4)))); spx = spx + 1; end end
				if spx == 8 then talk.mood = 0; talk.speech(1,text.tuto9); tutowhat = os.clock() + 60; spx = spx + 1; end -- 60
				if spx == 7 then if os.clock() > tutowhat then talk.mood = 1; talk.speech(1,text.tuto8); spx = spx + 1; end end
				if spx == 6 then if os.clock() > tutowhat then hud.a = 255; spx = spx + 1; tutowhat = os.clock() + 5; end end
				if spx == 5 then talk.mood = 1; talk.speech(1,text.tuto7); spx = spx + 1; tutowhat = os.clock() + 10; end
				if spx == 4 then talk.mood = 0; talk.speech(1,text.tuto6); spx = spx + 1; end
				if spx == 3 then talk.mood = 1; talk.speech(1,text.tuto3..os.date("%H:%M")..text.tuto4..os.nick()..text.tuto5); spx = spx + 1; end
				if spx == 2 then talk.mood = 2; talk.speech(1,text.tuto2); spx = spx + 1; end
				if spx == 1 then talk.speech(1,text.tuto1); spx = spx + 1; end
			end
			if not talk.showing and spx == 13 then en.m = 12; end
			if talk.showing and spx == 9 then tutowhat = os.clock() + 60; end -- 60
			if not talk.showing and spx == 9 then en.m = 5; end
			if spx == 10 then en.m = 0; tutowhat = os.clock() + 3; tutodone = true; spx = 11; end
			-- start frame
			local tot = math.max(en.l+1,wp.l+1);
			wp.cm = 1-wp.cm; -- change buffer;
			wp.c[wp.cm] = { { }, { }, { }, { }, { }, { }, { }, { }, { }, { } }; -- refresh collisions.
			stages.blit();
			pla.fly();
			for i=1, tot do en.update(i); wp.update(i); end
			en.spriteburst();
			pla.blit();
			pla.hudblit();
			im.blit("tuto");
			talk.blit();
			if controls.press("select") then pla.incabin = not pla.incabin; end
			screen.flip();
		end
		
		
		-- @game loop
		
		-- what happened.
		
		-- kill everybody.
	end
	if abc == 3 then options(); end
end


-- @Valley appear
os.exit();